Index: /inundation/fit_interpolate/benchmark_least_squares.py
===================================================================
--- /inundation/fit_interpolate/benchmark_least_squares.py	(revision 2183)
+++ /inundation/fit_interpolate/benchmark_least_squares.py	(revision 2184)
@@ -11,5 +11,5 @@
    test results.
    
-   Ole Nielsen, Stephen Roberts, Duncan Gray, Christopher Zoppou
+   Duncan Gray
    Geoscience Australia, 2004.
 """
@@ -56,5 +56,10 @@
               maxArea=1000,
               max_points_per_cell=4,
+              is_fit=True,
               save=False):
+        '''
+        num_of_points 
+        '''
+        
         #print "num_of_points",num_of_points
         #print "maxArea",maxArea
@@ -65,12 +70,12 @@
         m = Mesh()
         m.addUserVertex(0,0)
-        m.addUserVertex(100,0)
-        m.addUserVertex(0,100)
-        m.addUserVertex(100,100)
+        m.addUserVertex(1.0,0)
+        m.addUserVertex(0,1.0)
+        m.addUserVertex(1.0,1.0)
         
         m.autoSegment(alpha = 100 )
         
         dict = {}
-        dict['points'] = [[10,10],[90,20]]
+        dict['points'] = [[.10,.10],[.90,.20]]
         dict['segments'] = [[0,1]] 
         dict['segment_tags'] = ['wall1']   
@@ -78,5 +83,5 @@
     
         dict = {}
-        dict['points'] = [[10,90],[40,20]]
+        dict['points'] = [[.10,.90],[.40,.20]]
         dict['segments'] = [[0,1]] 
         dict['segment_tags'] = ['wall2']   
@@ -84,5 +89,5 @@
         
         dict = {}
-        dict['points'] = [[20,90],[60,60]]
+        dict['points'] = [[.20,.90],[.60,.60]]
         dict['segments'] = [[0,1]] 
         dict['segment_tags'] = ['wall3'] 
@@ -90,5 +95,5 @@
         
         dict = {}
-        dict['points'] = [[60,20],[90,90]]
+        dict['points'] = [[.60,.20],[.90,.90]]
         dict['segments'] = [[0,1]] 
         dict['segment_tags'] = ['wall4']   
@@ -99,10 +104,18 @@
             m.export_mesh_file("aaaa.tsh")
         mesh_dict =  m.Mesh2IOTriangulationDict()
-
+        #print "mesh_dict",mesh_dict
         points = []
         point_atts = []
+        vertex_atts = []
+
+              
+            
         for point in range(num_of_points):
             points.append([random()*100, random()*100])
             point_atts.append(10.0)
+
+        # There has to be a better way of doing this..
+        for vertex in mesh_dict['vertices']:
+            vertex_atts.append(10.0)
             
         #Initial time and memory
@@ -116,7 +129,12 @@
                                verbose = False,
                                max_points_per_cell = 4)
-        calc = interp.fit_points(point_atts )
-        #print "interp.expanded_quad_searches", interp.expanded_quad_searches
-        #print "calc", calc
+        if is_fit is True:
+            calc = interp.fit_points(point_atts)
+
+        else:
+            # run an interploate problem.
+            print "Interpolate!"
+            calc = interp.interpolate(vertex_atts)
+            
         time_taken_sec = (time.time()-t0)
         m1 = mem_usage()
@@ -126,3 +144,3 @@
             memory_used = (m1 - m0)
         #print 'That took %.2f seconds' %time_taken_sec
-        return time_taken_sec, memory_used
+        return time_taken_sec, memory_used, len(mesh_dict['triangles'])
Index: /inundation/fit_interpolate/run_long_benchmark.py
===================================================================
--- /inundation/fit_interpolate/run_long_benchmark.py	(revision 2184)
+++ /inundation/fit_interpolate/run_long_benchmark.py	(revision 2184)
@@ -0,0 +1,44 @@
+
+from benchmark_least_squares import BenchmarkLeastSquares
+
+ben = BenchmarkLeastSquares()
+
+ofile = 'lbm_results.txt'
+delimiter = ','
+
+is_fit_list = [True, False]
+num_of_points_list = [10, 1000, 100000, 10000000]
+maxArea_list = [0.1, 0.001, 0.00001, 0.0000001]
+max_points_per_cell_list = [8]
+
+fd = open(ofile,'a')
+# write the title line
+
+fd.write("num_of_points" + delimiter +
+         "maxArea" + delimiter +
+         "num_of_triangles" + delimiter +
+         "max_points_per_cell" + delimiter +
+         "is_fit" + delimiter +
+         "mem"  + delimiter +
+         "time" + delimiter + "\n")
+
+for is_fit in is_fit_list:
+    for num_of_points in num_of_points_list:
+        for maxArea in maxArea_list:
+            for max_points_per_cell in max_points_per_cell_list:
+    
+                time, mem, num_tri = ben.trial(num_of_points=num_of_points
+                                      ,maxArea=maxArea
+                                      ,max_points_per_cell=max_points_per_cell
+                                      ,is_fit=is_fit
+                                      )
+                print "time",time
+                print "mem", mem
+                fd.write(str(is_fit) + delimiter +
+                         str(num_of_points) + delimiter +
+                         str(maxArea) + delimiter +
+                         str(num_tri) + delimiter +
+                         str(max_points_per_cell) + delimiter +
+                         str(mem)  + delimiter +
+                         str(time) + delimiter + "\n")
+fd.close()                         